﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace DistributedGA.Core.Util {
  public class ByteArrayWrapper {
    public static int AliveCounter;
    public static int AllocatedCounter;
    public static int FreedCounter;

    public static ByteArrayWrapper CreateByteArrayWrapper(byte[] arr) {
      return new ByteArrayWrapper(arr);
    }

    public byte[] Array { get; private set; }

    private ByteArrayWrapper(byte[] arr) {
      Interlocked.Increment(ref AliveCounter);
      Interlocked.Increment(ref AllocatedCounter);
      this.Array = arr;
    }

    ~ByteArrayWrapper() {
      Interlocked.Decrement(ref AliveCounter);
      Interlocked.Increment(ref FreedCounter);
    }
  }
}
